import pathlib
import sys
import unittest.mock as mock

import pytest


@pytest.fixture(autouse=True, scope="session")
def add_to_path():
    """
    Add the code dir and pypath modules to the current python path
    """
    CODE_DIR = str(pathlib.Path(__file__).parent.parent.absolute())
    TPATH_DIR = str(pathlib.Path(__file__).parent / "pypath")

    with mock.patch(
        "sys.path", [CODE_DIR, TPATH_DIR] + [x for x in sys.path if not x == CODE_DIR]
    ):
        yield


@pytest.fixture(autouse=True, scope="session")
def clean_cli_args():
    with mock.patch("sys.argv", ["config"]):
        yield


@pytest.fixture(autouse=True, scope="session")
def clean_os_vars():
    with mock.patch("os.environ", {}):
        yield
