import pathlib
import unittest.mock as mock

import pop.hub


CPATH_DIR = pathlib.Path(__file__).parent.parent / "config"


def test_ordering_1():
    hub = pop.hub.Hub()
    hub.pop.sub.add(dyne_name="config")
    with mock.patch(
        "os.environ",
        {"OS_ALONE": "os", "OS_CLI": "os", "ALLS": "os", "OS_BASE_SOURCE": "os"},
    ):
        with mock.patch(
            "sys.argv",
            [
                "config",
                "--config",
                str(CPATH_DIR / "full.conf"),
                "--alls",
                "cli",
                "--oscli",
                "cli",
                "--exdyned1",
                "EXDYNED1",
                "--exdyned2",
                "EXDYNED2",
                "--exdyned3",
                "EXDYNED3",
                "--exdyned4",
                "EXDYNED4",
            ],
        ):
            hub.config.integrate.load(["full", "d1", "m1", "m2"], "full", ["d1"])
    assert hub.OPT.d1.exdyned1 == "EXDYNED1"
    assert hub.OPT.d1.exdyned2 == "EXDYNED2"
    assert hub.OPT.d1.exdyned3 == "EXDYNED3"
    assert hub.OPT.d1.exdyned4 == "EXDYNED4"
    assert hub.OPT.m2.base == "os"
    assert hub.OPT.full.alls == "cli"
    assert hub.OPT.full.oscli == "cli"
    assert hub.OPT.full.osalone == "os"
